summaryrefslogtreecommitdiff
path: root/tests/tsort
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>1999-08-22 15:54:35 +0000
committerJim Meyering <jim@meyering.net>1999-08-22 15:54:35 +0000
commit9715e45a875aa8c74b4968aefa8a08a87875a3be (patch)
treecef0cd45710cf7ba24790c4939e40f0ef42dca2b /tests/tsort
parent5d3b0307987161b2d6b27c1a26291f019bb7942f (diff)
downloadcoreutils-9715e45a875aa8c74b4968aefa8a08a87875a3be.tar.xz
*** empty log message ***
Diffstat (limited to 'tests/tsort')
-rw-r--r--tests/tsort/.cvsignore7
-rwxr-xr-xtests/tsort/basic-143
2 files changed, 43 insertions, 7 deletions
diff --git a/tests/tsort/.cvsignore b/tests/tsort/.cvsignore
index 852508156..f3c7a7c5d 100644
--- a/tests/tsort/.cvsignore
+++ b/tests/tsort/.cvsignore
@@ -1,8 +1 @@
-*.I
-*.E
-*.X
-*.O
-*-tests
-build-script
Makefile
-mk-script
diff --git a/tests/tsort/basic-1 b/tests/tsort/basic-1
new file mode 100755
index 000000000..81297d11c
--- /dev/null
+++ b/tests/tsort/basic-1
@@ -0,0 +1,43 @@
+#!/bin/sh
+
+: ${PERL=perl}
+: ${srcdir=.}
+
+case "$PERL" in
+ *'missing perl')
+ echo 1>&2 "$0: configure didn't find a usable version of Perl, so can't run this test"
+ exit 77
+ ;;
+esac
+#'
+
+exec $PERL -w -I$srcdir/.. -MFetish -- - <<\EOF
+#/
+require 5.003;
+use strict;
+
+(my $program_name = $0) =~ s|.*/||;
+
+# Turn off localisation of executable's ouput.
+@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+
+my @Tests =
+ (
+ ['cycle-1', {IN => {f => "t b\nt s\ns t\n"}}, {OUT => ''}, {EXIT => 1},
+ {ERR => "tsort: f: input contains a loop:\ntsort: s\ntsort: t\n"} ],
+ ['cycle-2', {IN => {f => "t x\nt s\ns t\n"}}, {OUT => ''}, {EXIT => 1},
+ {ERR => "tsort: f: input contains a loop:\ntsort: s\ntsort: t\n"} ],
+
+ ['posix-1', {IN => "a b c c d e\ng g\nf g e f\nh h\n"},
+ {OUT => "a\nc\nd\nh\nb\ne\nf\ng\n"}],
+ ['posix-2', {IN => "b a\nd c\nz h x h r h\n"},
+ {OUT => "b\nd\nr\nx\nz\na\nc\nh\n"}],
+ );
+
+my $save_temps = $ENV{DEBUG};
+my $verbose = $ENV{VERBOSE};
+
+my $prog = $ENV{PROG} || die "$0: \$PROG not specified in environment\n";
+my $fail = run_tests ($program_name, $prog, \@Tests, $save_temps, $verbose);
+exit $fail;
+EOF